/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component.model;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle ;

import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.UIGrid;

/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: ActionCell.java,v 1.1 2004/07/02 02:35:21 tuan08 Exp $
 */
public class ActionCell extends Cell {
  private List buttons_ ;
  
  public ActionCell() {
    buttons_ = new ArrayList(3) ;
  }
  
  public ActionCell add(Button button) { 
    buttons_.add(button) ; 
    return this ;
  } 
  
  public ActionCell add(boolean activate, Button button) {
    if(!activate) {
      button.setActivate(false) ;  
    }
    buttons_.add(button) ; 
    return this ;
  } 
  
  public void render(ResponseWriter w, ResourceBundle res, UIGrid uiGrid, String cellTag) throws IOException { 
  	w.write("<td") ;
  	if(attributes_ != null) {
  		int size = attributes_.size() ;
  		for(int i = 0; i < size ; i++) {
  			Cell.Attribute attr = (Cell.Attribute) attributes_.get(i) ;
  			w.write(' '); w.write(attr.name_); w.write("='"); w.write(attr.value_);w.write('\'') ;
  		}
  	}
  	w.write('>') ;
  	for(int i = 0; i < buttons_.size(); i++) {
  		Button button = (Button)buttons_.get(i);
  		button.render(w, res, uiGrid) ;
  	}
  	w.write("</td>") ;
  }
}