/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component.model;

import java.io.IOException;
import java.util.ResourceBundle;
import javax.faces.context.ResponseWriter;
import org.exoplatform.commons.utils.ExpressionUtil;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.UIGrid;

/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: Button.java,v 1.10 2004/10/18 22:06:09 benjmestrallet Exp $
 */
public class PopupWindowButton extends Button {
  
  public PopupWindowButton(String name, String url) {
    super(name, (String)null) ;
    parameters_ = "javascript: newWindow = window.open('" + url + "','exowindow','height=200,width=150');" +
                  "if (window.focus) newWindow.focus() ;" ;
  }
  
  public void render(ResponseWriter w, ResourceBundle res, UIGrid uiParent) throws IOException {
    if(!isVisible()) return;
    //window.open(url,'name','height=200,width=150')
    w.write("<span");
    w.write(" onclick=\""); w.write(parameters_); w.write("\">");
    w.write(ExpressionUtil.getExpressionValue(res,label_));
    w.write("</span>");
  }
  
  public void render(ResponseWriter w, ResourceBundle res, 
                     UIExoComponent uiParent, String objectId) throws IOException {
    if(!isVisible()) return;
    w.write("<a");
    w.write(" href=\"\""); 
    w.write(" onclick=\""); w.write(parameters_); w.write("\">");
    w.write(ExpressionUtil.getExpressionValue(res,label_));
    w.write("</a>");
  }  
}
