/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.faces.core.renderer.html;

import java.io.IOException;
import java.util.ResourceBundle;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.Constants;
import org.exoplatform.faces.core.component.UIPageListIterator;

public class PageListIteratorRenderer extends HtmlBasicRenderer {
  public void encodeBegin(FacesContext context, UIComponent component) throws IOException {
    UIPageListIterator uiIterator = (UIPageListIterator) component  ;
    ResponseWriter w = context.getResponseWriter();
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext()) ;
    String baseURL = uiIterator.getBaseURL() ;
    w.write("<div class='UIPageIterator'>") ;
    int availablePage = uiIterator.getAvailablePage() ;
    int currentPage = uiIterator.getCurrentPage() ;
    w.write("<label>Total:"); w.write("&nbsp;"); w.write(Integer.toString(availablePage) + " pages"); w.write("</label>");
    w.write("&nbsp;");    
    if(currentPage - 1 > 0) {
        w.write("<span><a href='"); w.write(baseURL);
        w.write(Constants.AMPERSAND); w.write(UIPageListIterator.PAGE_PARAM); w.write('=');w.write(Integer.toString(1));
        w.write("'>");
        w.write(res.getString("UIPageIterator.button.first"));  
        w.write("</a></span>");
        w.write("&nbsp;") ;        
      if(currentPage - 10 > 0){
        w.write("<span><a href='"); w.write(baseURL);
        w.write(Constants.AMPERSAND); w.write(UIPageListIterator.PAGE_PARAM); w.write('=');w.write(Integer.toString(currentPage - 10));
        w.write("'>");
        w.write(res.getString("UIPageIterator.button.prev10pages"));  
        w.write("</a></span>");
        w.write("&nbsp;") ;
      }else {
        w.write("<span>"); w.write(res.getString("UIPageIterator.button.prev10pages")); w.write("</span>");
        w.write("&nbsp;") ;
      }
      w.write("<span><a href='"); w.write(baseURL);
      w.write(Constants.AMPERSAND); w.write(UIPageListIterator.PAGE_PARAM); w.write('=');w.write(Integer.toString(currentPage - 1));
      w.write("'>");
      w.write(res.getString("UIPageIterator.button.prev"));  
      w.write("</a></span>");
      w.write("&nbsp;") ;
    } else {
      w.write("<span>"); w.write(res.getString("UIPageIterator.button.first")); w.write("</span>");
      w.write("&nbsp;") ;
      w.write("<span>"); w.write(res.getString("UIPageIterator.button.prev10pages")); w.write("</span>");
      w.write("&nbsp;") ;
      w.write("<span>"); w.write(res.getString("UIPageIterator.button.prev")); w.write("</span>");
      w.write("&nbsp;") ;
    }
    int start = currentPage - 10 ;
    if(start < 1) start = 1 ;
    int stop = start + 9 ;
    if(stop > availablePage) stop = availablePage ;
    for(int i= start ; i <= stop; i++) {
      String num = Integer.toString(i) ;
      if(i == currentPage) {
        w.write("<span class='selected'>"); w.write(Integer.toString(i)); w.write("</span>");        
      } else {
        w.write("<span><a href='"); w.write(baseURL) ;
        w.write(Constants.AMPERSAND); w.write(UIPageListIterator.PAGE_PARAM); w.write('='); w.write(num);
        w.write("'>") ;
        w.write(num) ;
        w.write("</a></span>");        
      }
      if(i < stop) 
        w.write("<span>.&nbsp;</span>");
      else
        w.write("&nbsp;");
    }    
    if(currentPage + 1 <= availablePage) {
      w.write("<span><a href='"); w.write(baseURL) ;
      w.write(Constants.AMPERSAND); w.write(UIPageListIterator.PAGE_PARAM); 
      w.write('=');w.write(Integer.toString(currentPage + 1));
      w.write("'>") ;
      w.write(res.getString("UIPageIterator.button.next")) ;
      w.write("</a></span>");
      w.write("&nbsp;") ;
      if(currentPage + 10 <= availablePage){
        w.write("<span><a href='"); w.write(baseURL) ;
        w.write(Constants.AMPERSAND); w.write(UIPageListIterator.PAGE_PARAM); 
        w.write('=');w.write(Integer.toString(currentPage + 10));
        w.write("'>") ;
        w.write(res.getString("UIPageIterator.button.next10pages")) ;
        w.write("</a></span>");
        w.write("&nbsp;") ;
      }else {
        w.write("<span>"); w.write(res.getString("UIPageIterator.button.next10pages")); w.write("</span>");
        w.write("&nbsp;") ;
      }            
      w.write("<span><a href='"); w.write(baseURL) ;
      w.write(Constants.AMPERSAND); w.write(UIPageListIterator.PAGE_PARAM); 
      w.write('=');w.write(Integer.toString(availablePage));
      w.write("'>") ;
      w.write(res.getString("UIPageIterator.button.last")) ;
      w.write("</a></span>");
      w.write("&nbsp;") ;
    } else {
      w.write("<span>"); w.write(res.getString("UIPageIterator.button.next")); w.write("</span>");
      w.write("&nbsp;") ;
      w.write("<span>"); w.write(res.getString("UIPageIterator.button.next10pages")); w.write("</span>");
      w.write("&nbsp;") ;
      w.write("<span>"); w.write(res.getString("UIPageIterator.button.last")); w.write("</span>");
      w.write("&nbsp;") ;
    }
    /*int available  = uiIterator.getAvailable() ;
    int from = uiIterator.getFrom() + 1 ;
    if(available == 0) from  = 0 ;
    Object[] args = {new Integer(from), new Integer(uiIterator.getTo()),  new Integer(available)} ;
    String status = ft_.format(res.getString("UIPageIterator.label.status"), args) ;
    w.write("<div class='status'>"); w.write(status); w.write("</div>") ;
    w.write("</div>") ;
    */
  }
}