/*
 * Created on Mar 15, 2005
 */
package org.exoplatform.faces.core.renderer.html;

import java.io.IOException;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.faces.core.component.UIHiddenInput;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.Row;

/**
 * @author benjaminmestrallet
 */
public class SimpleMultipartFormRenderer extends SimpleFormRenderer{

  public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {
    ResponseWriter w = context.getResponseWriter() ;
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext()) ;
    UISimpleForm uiForm = (UISimpleForm) component ; 
    String actionURL = uiForm.getBaseURL(context) ;
    String formName = uiForm.getFormName() ;
    //String formId = uiForm.getFormId() ;
    String method = uiForm.getMethod()  ;
    String clazz = uiForm.getClazz() ;
    if(clazz == null) clazz = "" ;
    w.write("<form id='"); w.write(formName); w.write("'") ;
    w.write(" action='"); w.write(actionURL); w.write("'") ;
    if(method != null){ 
      w.write(" method='"); w.write(method); w.write("'") ;
    }
    w.write(" enctype='multipart/form-data' class='UISimpleForm");
    if(clazz != null)  {
      w.write(' ') ; w.write(clazz) ;
    } 
    w.write("'>\n");
    w.write("<input type='hidden' name='"); w.write(ACTION); w.write("'") ;
    w.write(" value=''/>\n") ;
    List hiddenInputs = uiForm.getHiddenInputs() ;
    if(hiddenInputs != null) {
      for (int i = 0; i < hiddenInputs.size(); i++) {
        UIHiddenInput uiInput = (UIHiddenInput) hiddenInputs.get(i) ;
        uiInput.encodeBegin(context) ;
      }
    }
    w.  write("<table>\n") ;
    List rows = uiForm.getRows() ;
    for (int i = 0 ; i < rows.size() ; i++) {
      Row row = (Row) rows.get(i) ;
      row.render(w, res, uiForm) ;
    }
    w.  write("</table>") ;
    w.write(getScript(uiForm));
    w.write("</form>") ;
  }  
  
  
}
