package org.exoplatform.velocity.directive;

import java.io.IOException;
import java.io.Writer;
import java.util.List;
import javax.faces.context.FacesContext;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.directive.Directive;
import org.apache.velocity.runtime.parser.node.Node;
import org.exoplatform.faces.core.component.UIHiddenInput;
import org.exoplatform.faces.core.component.UISimpleForm ;
import org.exoplatform.faces.core.component.UISimpleMulltipartForm ;
import org.exoplatform.faces.core.component.UIExoComponent ;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since March 3, 2005
 * @version $Id$
 */
public class JSFForm extends Directive {
  public String getName()  {    return "jsfForm"; }        
  
  public int getType() {  return BLOCK; }        
  
  public void init(RuntimeServices rs, InternalContextAdapter context, Node node) throws Exception {
    super.init(rs, context, node);
  }
  
  public boolean render(InternalContextAdapter context,  Writer w, Node node)
  throws IOException,  MethodInvocationException, ResourceNotFoundException, ParseErrorException {
    UISimpleForm uiForm = (UISimpleForm)context.get(UIExoComponent.UICOMPONENT) ;
    FacesContext facescontext = FacesContext.getCurrentInstance() ;
    String actionURL = uiForm.getBaseURL(facescontext) ;
    String formName = uiForm.getFormName() ;
    //String formId = uiForm.getFormId() ;
    String method = uiForm.getMethod() ;
    String clazz = uiForm.getClazz() ;
    if(clazz == null) clazz = "UIExoForm" ;
    w.write("<form id='"); w.write(formName); w.write("'") ;
    w.write(" action='"); w.write(actionURL); w.write("'") ;
    if(method != null){ 
      w.write(" method='"); w.write(method); w.write("'") ;
    }
    if(uiForm instanceof UISimpleMulltipartForm) {
      w.write(" enctype='multipart/form-data'");
    }
    //w.write(" class='UISimpleForm "); w.write(clazz) ;
    w.write(">\n");
    w.write("<div>\n");
    w.write("<input type='hidden' name='"); w.write(UIExoComponent.ACTION); w.write("'") ;
    w.write(" value=''/>\n") ;
    w.write("</div>\n");
    List hiddenInputs = uiForm.getHiddenInputs() ;
    if(hiddenInputs != null) {
      for (int i = 0; i < hiddenInputs.size(); i++) {
        UIHiddenInput uiInput = (UIHiddenInput) hiddenInputs.get(i) ;
        uiInput.encodeBegin(facescontext) ;
      }
    }
    node.jjtGetChild(0).render(context, w);
    //w.write(uiForm.getScript());////
    w.write("</form>") ;
    return true;
  }
}