/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.component;

import javax.faces.render.Renderer;

import org.exoplatform.container.component.ExecutionContext;
import org.exoplatform.container.component.ExecutionUnit;
import org.exoplatform.container.xml.InitParams;
import org.exoplatform.portal.faces.renderer.BaseRenderer;
import org.exoplatform.portal.faces.renderer.html.container.ContainerRenderer;
import org.exoplatform.portal.faces.renderer.html.page.PageRenderer;
import org.exoplatform.portal.faces.renderer.html.portal.PortalRenderer;
import org.exoplatform.portal.faces.renderer.html.portlet.PortletRenderer;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Sep 19, 2005
 */
public class UIComponentRenderCommand extends  ExecutionUnit {
  
  public UIComponentRenderCommand() {
    
  }
 
  public UIComponentRenderCommand(InitParams params) {
    
  }

  public Object execute(ExecutionContext executionContext) throws Throwable  {
    CommandExecutionContext context = (CommandExecutionContext)  executionContext ;
    String decorator = context.uicomponent.getDecorator() ;
    Renderer renderer  = context.uicomponent.getRenderer(context.fcontext) ; 
    if(renderer instanceof PortalRenderer || 
       renderer instanceof ContainerRenderer ||
       renderer instanceof PageRenderer ||
       renderer instanceof PortletRenderer ) {
       renderer.encodeChildren(context.fcontext, context.uicomponent) ;
    } else if(renderer instanceof BaseRenderer) {
      BaseRenderer brenderer =  (BaseRenderer) renderer ;
      brenderer.startRenderEditMode(context.fcontext, context.uicomponent) ;
      brenderer.renderViewMode(context.fcontext, context.uicomponent) ;
      brenderer.endRenderEditMode(context.fcontext, context.uicomponent) ;
    } else {
      renderer.encodeBegin(context.fcontext, context.uicomponent) ;
      renderer.encodeChildren(context.fcontext, context.uicomponent) ;
      renderer.encodeEnd(context.fcontext, context.uicomponent) ;
    }
    return null;
  }
}