/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.renderer.html.container;

import java.io.IOException;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.portal.faces.component.UIPortalComponent;
import org.exoplatform.portal.faces.component.UIContainer;

/**
 * Date: March 3, 2005
 * 
 * @author: Michael Joseph Walsh
 * @email: walsh@je.jfcom.mil
 * @version: $Id: CollapsibleRenderer.java,v 1.0 Exp $
 */
public class CollapsibleRenderer extends ContainerRenderer {

  public void renderViewMode(FacesContext context, UIPortalComponent uiComponent) throws IOException {
    UIContainer uiContainer = (UIContainer) uiComponent ;
    ResponseWriter w = context.getResponseWriter();
    List children = uiContainer.getChildren();
    if (children.size() == 0)    return;
    w.write("<span id='show_" + uiContainer.getId()
        + "' style='DISPLAY: none'>");
    w.write("<table class='");
    w.write(uiContainer.getDecorator());
    w.write("-container'");
    w.write(" id='");
    w.write(uiContainer.getId());
    w.write("'>");
    w.write("<tr>");
    w.write("<td align=right>");
    w
      .write("<a href='javascript:show_"
          + uiContainer.getId()
          + "()'><image src='/portal/images/expand.gif' width='25' height='25' border='0'/></a>");
    w.write("</td>");
    w.write("</tr>");
    w.write("</table>");
    w.write("</span>");
    // TODO: replace text with icon
    w.write("<span id='hide_" + uiContainer.getId() + "' style='DISPLAY: block'>");
    // Renders only on container inside the collapsible container
    if (children.size() > 0) {
      UIPortalComponent uiChild = (UIPortalComponent) children.get(0);
      uiChild.encodeBegin(context);
      uiChild.encodeChildren(context);
      uiChild.encodeEnd(context);
    }
    w.write("<table>");
    w.write("<tr>");
    w.write("<td align=right>");
    w
      .write("<a href='javascript:hide_"
          + uiContainer.getId()
          + "()'><image src='/portal/images/collapse.gif' width='25' height='25' border='0'/></a>");
    w.write("</td>");
    w.write("</tr>");
    w.write("</table>");
    w.write("</span>\n");
    w.write(getScript(uiContainer)) ;
  }

  private String getScript(UIContainer uiContainer) {
    String id  = uiContainer.getId() ;
    String script  = 
    "<script language='javascript' type='text/javascript'>\n" +
    "<!--\n" +
    "function show_" + id + "() {\n" +
    "  document.cookie = '" + id  + "' + '=shown;path=/;expires=Monday, 04-Apr-2010 05:00:00 GMT';\n" +
    "  obj = document.getElementById(\"hide_" + id  + "\"); " +
    "  obj.style.display = \"block\";\n" +
    "  obj = document.getElementById(\"show_" + id  + "\"); " + 
    "  obj.style.display = \"none\";\n" +
    "}\n" +
    
    "function hide_" + id + "() {\n" +
    "  document.cookie = '" +  id + "' + '=hidden;path=/;expires=Monday, 04-Apr-2010 05:00:00 GMT';\n" +
    "  alert('is ' + document.cookie);" +
    "  obj = document.getElementById(\"hide_" + id + "\");" + 
    "  obj.style.display = \"none\";\n" +
    "  obj = document.getElementById(\"show_" + id + "\");" + 
    "  obj.style.display = \"block\";\n" +
    "}\n\n" ;
    if (uiContainer.getMode() == UIPortalComponent.COMPONENT_VIEW_MODE) {
      script +=
      "dc = document.cookie;\n" +
      "prefix = '" + id + "=';\n" +
      "begin = dc.indexOf('; ' + prefix);\n" +
      "if (begin == -1) {\n" +
      "  begin = dc.indexOf(prefix);\n" +
      "  if ((begin == 0) || (begin == -1)) {\n" +

      "    if ((dc.indexOf(prefix+'hidden') == 0) || (dc.indexOf(prefix+'hidden') == -1)) {\n" +
      "      hide_" + id + "();\n" +
      "    } else if (dc.indexOf(prefix+'shown') == 0) {\n" +
      "      show_" + id + "();\n" +
      "    }" +
      "  }\n" +
      "} else {\n" +
      "  begin += 2;\n" +
      "  end = document.cookie.indexOf(';', begin);\n" +
      "  if (end == -1) {\n" +
      "    end = dc.length;\n" +
      "  }\n" +
      
      "  if (unescape(dc.substring(begin + prefix.length, end)) != null) {\n" +
      "    if (unescape(dc.substring(begin + prefix.length, end)) == 'shown') {\n" +
      "      show_" + id + "();\n" +
      "    } else {\n" +
      // w.write("alert('calling hide');");
      "      hide_" + uiContainer.getId() + "();\n" +
      "    }\n" +
      "  }\n" +
      "}\n" ;
    } 
    script +=
    "// -->\n" +
    "</script>\n" ;
    return script ;
  }
}
