package org.exoplatform.portlet.commons.wrapper;

import javax.servlet.ServletContext;
import java.util.Set;
import java.net.URL;
import java.net.MalformedURLException;
import java.io.InputStream;
import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import java.util.Enumeration;
import org.apache.commons.logging.LogFactory;

import org.apache.commons.logging.Log;

public class ServletContextWrapper implements ServletContext{
    protected ServletContext servletContext;
    protected static Log log = LogFactory.getLog(ServletContextWrapper.class);

    public ServletContextWrapper (ServletContext servletContext){
        log.debug("ServletContextWrapper is created");
        this.servletContext = servletContext;
    }

    public RequestDispatcher getRequestDispatcher(String string) {
        log.debug("getRequestDispatcher wrapped ["+string+"]");
        return new RequestDispatcherWrapper(
            servletContext.getRequestDispatcher(string));
    }

    public RequestDispatcher getNamedDispatcher(String string) {
        log.debug("getNamedDispatcher wrapped ["+string+"]");
        return new RequestDispatcherWrapper(
            servletContext.getNamedDispatcher(string));
    }

//-- delegate

    public ServletContext getContext(String string) {
        return servletContext.getContext(string);
    }

    public int getMajorVersion() {
        return servletContext.getMajorVersion();
    }

    public int getMinorVersion() {
        return servletContext.getMinorVersion();
    }

    public String getMimeType(String string) {
        return servletContext.getMimeType(string);
    }

    public Set getResourcePaths(String string) {
        return servletContext.getResourcePaths(string);
    }

    public URL getResource(String string) throws MalformedURLException {
        return servletContext.getResource(string);
    }

    public InputStream getResourceAsStream(String string) {
        return servletContext.getResourceAsStream(string);
    }

    public Servlet getServlet(String string) throws ServletException {
        return null;
    }

    public Enumeration getServlets() {
        return new java.util.Vector().elements();
    }

    public Enumeration getServletNames() {
        return new java.util.Vector().elements();
    }

    public void log(String string) {
        servletContext.log(string);
    }

    public void log(Exception exception, String string) {
    }

    public void log(String string, Throwable throwable) {
        servletContext.log(string ,throwable);
    }

    public String getRealPath(String string) {
        return servletContext.getRealPath(string);
    }

    public String getServerInfo() {
        return servletContext.getServerInfo();
    }

    public String getInitParameter(String string) {
        return servletContext.getInitParameter(string);
    }

    public Enumeration getInitParameterNames() {
        return servletContext.getInitParameterNames();
    }

    public Object getAttribute(String string) {
        return servletContext.getAttribute(string);
    }

    public Enumeration getAttributeNames() {
        return servletContext.getAttributeNames();
    }

    public void setAttribute(String string, Object object) {
        servletContext.setAttribute(string, object);
    }

    public void removeAttribute(String string) {
        servletContext.removeAttribute(string);
    }

    public String getServletContextName() {
        return servletContext.getServletContextName();
    }
}
