/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.component;

import java.util.Collection;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.UIGrid;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.UIComponentObserver;
import org.exoplatform.services.organization.Group;

/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIViewUserInGroup.java,v 1.1 2004/10/22 14:23:30 tuan08 Exp $
 */
public class UIViewUserInGroup extends UIGrid {  
  
	UIPageListIterator uiPageIterator_ ;
  UIMembershipForm uiMembershipForm_ ;
	
	public UIViewUserInGroup() throws Exception {
    setRendererType("VelocityRenderer") ;
    uiMembershipForm_ = new UIMembershipForm() ;
    uiMembershipForm_.setRendered(false);
    uiMembershipForm_.setId("UIMembershipFormForGroup") ;
		uiPageIterator_ = new UIPageListIterator(new PageListDataHandler()) ;
    getChildren().add(uiPageIterator_) ;
    getChildren().add(uiMembershipForm_) ;		
	}
  
  public Collection getListUserInGroup() throws Exception { 
    return uiPageIterator_.getPageListDataHandler().getDatas() ;
  }
  
 public void registerComponentObserver(UIExoComponent parent)  {
	  UIGroupExplorer uiExplorer = 
      (UIGroupExplorer) parent.getAncestorOfType(UIGroupExplorer.class) ;
    uiExplorer.addObserver(new GroupChangeObserver());
	}
	
 public void update() throws Exception { 
    UIGroupExplorer uiExplorer = 
      (UIGroupExplorer) getAncestorOfType(UIGroupExplorer.class) ;
    uiPageIterator_.setPageList(uiExplorer.getMemberOfTheCurrentGroup()) ;
  }
  
	public class GroupChangeObserver extends UIComponentObserver {
	  public void onChange(UIExoComponent target) throws Exception  {
	    UIGroupExplorer uiExplorer = (UIGroupExplorer) target ;
      uiPageIterator_.setPageList(uiExplorer.getMemberOfTheCurrentGroup()) ;
      Group group  = uiExplorer.getCurrentGroup();
      if(group == null) {
        uiMembershipForm_.setRendered(false);
      } else {
        uiMembershipForm_.setRendered(true);
        uiMembershipForm_.populateFormByGroup(group.getId());
      }
	  }
	}
}