/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.impl;

import org.exoplatform.services.portal.model.Permission;
import org.exoplatform.services.portal.model.PortalConfig;
/**
 * Created by The eXo Platform SARL        .
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Date: Jun 14, 2003
 * Time: 1:12:22 PM
 *
 * @hibernate.class  table="EXO_PORTAL_CONFIG"
 */
public class PortalConfigData extends PortalConfigDescriptionData {
  transient private PortalConfig config_ ; 

  public PortalConfigData() { }

  public PortalConfigData(String xml ) throws Exception {  
    setData(xml) ;
  }

  public PortalConfigData(PortalConfig config) throws Exception {   
    setPortalConfig(config) ;
  }
  
  /**
   * @hibernate.property length="65535" type="org.exoplatform.services.database.impl.TextClobType"
   **/
  public String getData() throws Exception { 
    String xml =  PortalConfigServiceImpl.toXML(config_) ;    
    return xml ;   
  }

  public void  setData(String s) throws Exception { 
    config_ = (PortalConfig) PortalConfigServiceImpl.fromXML(s, PortalConfig.class) ;
    setOwner(config_.getOwner()) ;
    Permission perm = config_.getViewPermission() ;
    if(perm != null) viewPermission =  perm.toString() ;
    perm = config_.getEditPermission() ;
    if(perm != null) editPermission =  perm.toString() ;
  }

  public PortalConfig getPortalConfig() { return config_ ; }
  public void  setPortalConfig(PortalConfig config) { 
    config_ = config ;   
    setOwner(config_.getOwner()) ;   
    Permission perm = config_.getViewPermission() ;   
    if(perm != null) viewPermission =  perm.toString() ;  
    perm = config_.getEditPermission() ;    
    if(perm != null) editPermission =  perm.toString() ;    
  }
}
