/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.impl.converter.v11tov2;

import java.util.ArrayList;
import java.util.Iterator;

import org.exoplatform.services.backup.XMLObjectConverter;
import org.exoplatform.services.portal.model.Body;
import org.exoplatform.services.portal.model.Container;
import org.exoplatform.services.portal.model.Page;
import org.exoplatform.services.portal.model.PageNode;
import org.exoplatform.services.portal.model.Permission;
import org.exoplatform.services.portal.model.PortalConfig;
import org.exoplatform.services.portal.model.Portlet;
import org.exoplatform.services.portal.model.PortletPreferences;
import org.exoplatform.services.portal.model.Preference;
import org.exoplatform.xml.object.XMLCollection;
import org.exoplatform.xml.object.XMLEntry;
import org.exoplatform.xml.object.XMLField;
import org.exoplatform.xml.object.XMLMap;
import org.exoplatform.xml.object.XMLObject;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Apr 20, 2005
 * @version $Id$
 */
public class V11XMLObjectConverter extends XMLObjectConverter {
  
  static String PORTAL_CONFIG_TYPE = PortalConfig.class.getName().intern() ;
  static String BODY_TYPE = Body.class.getName().intern() ;
  static String PAGE_TYPE = Page.class.getName().intern() ;
  static String CONTAINER_TYPE = Container.class.getName().intern() ;
  static String PORTLET_TYPE = Portlet.class.getName().intern()  ;
  static String PAGE_NODE_TYPE = PageNode.class.getName().intern() ;  
  
  Converter convert = new Converter(); 
  
  public void update(XMLObject xmlobject) {
    String type = xmlobject.getType() ;      
    if(PORTAL_CONFIG_TYPE.equals(type)) {
      try{              
        convert.convertPortalConfig( xmlobject);
      }catch( Exception exp) {
        exp.printStackTrace();
      }          
    } else if(BODY_TYPE.equals(type)) {     
      try{
        convert.convertBody( xmlobject);
      }catch( Exception exp){
        exp.printStackTrace();
      }
    } else if(PAGE_TYPE.equals(type)) {
      try{
        convert.convertPage( xmlobject);
      }catch( Exception exp){
        exp.printStackTrace();
      }
    } else if(CONTAINER_TYPE.equals(type)) {
      try{
        convert.convertContainer( xmlobject);
      }catch( Exception exp){
        exp.printStackTrace();
      }
    } else if(PORTLET_TYPE.equals(type)) {
      try{              
        convert.convertPortlet( xmlobject);
      }catch( Exception exp) {
        exp.printStackTrace();
      }    
    } else if(PAGE_NODE_TYPE.equals(type)) {
      try{              
        convert.convertPageNode( xmlobject);
      }catch( Exception exp) {
        exp.printStackTrace();
      }    
    }   
  }
  
  public void pack(XMLObject xmlobject) {
    if(PORTAL_CONFIG_TYPE.equals( xmlobject.getType())) {
      try{              
        convert.pack( xmlobject);
      }catch( Exception exp) {
        exp.printStackTrace();
      }       
    }
  }
  
}
