/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.log.impl;

import java.util.Date;

import org.exoplatform.services.portal.log.PortalLogData;
/**
 * Created by The eXo Platform SARL
 * Author : Hung Nguyen
 *          nqhungvn@users.sourceforge.net
 * Sep 26, 2005
 * @hibernate.class  table="PORTAL_LOG_DATA"
 */
public class PortalLogDataImpl implements PortalLogData {
  private String id ;
  private String portalOwner ;
  private String portalId ;
  private Date   timeSlot ;
  private int    timeIndex ;
  private String strTimeSlot ;
  private String strTimeIndex ;
  private long   accessCounter ;
  private long   illegalAccessCounter ;
  private long   errorCounter ;
  private long   summaryAccessTime ; 
  
  public PortalLogDataImpl(){
    accessCounter = 0 ;
    illegalAccessCounter = 0 ;
    errorCounter = 0 ;
    summaryAccessTime = 0 ;
  }
  /**
   * @hibernate.id  generator-class="assigned" unsaved-value="null"
   ***/
  public String getId() {  return id ; }
  public void   setId(String s) {  id = s ; }
  
  /**
   * @hibernate.property
   ***/
  public String getPortalId(){ return portalId ; }
  public void   setPortalId(String s) { portalId = s ; }
  
  /**
   * @hibernate.property
   ***/
  public String getPortalOwner(){ return portalOwner ; }
  public void   setPortalOwner(String s) { portalOwner = s ; }
  
  /**
   * @hibernate.property
   ***/
  public Date getTimeSlot() { return timeSlot ; }
  public void setTimeSlot(Date d) { timeSlot = d ; }
  
  /**
   * @hibernate.property
   ***/
  public String getStrTimeSlot() { return strTimeSlot ; }
  public void   setStrTimeSlot(String s) { strTimeSlot = s ; }
  
   /**
   * @hibernate.property
   ***/
  public String getStrTimeIndex() { return strTimeIndex ; }
  public void   setStrTimeIndex(String s) { strTimeIndex = s ; }
  
  /**
   * @hibernate.property
   ***/
  public int  getTimeIndex() { return timeIndex ; }
  public void setTimeIndex(int i) { timeIndex = i ; }
  
  /**
   * @hibernate.property
   ***/
  public long getAccessCounter() {  return accessCounter ; }
  public void setAccessCounter(long c) {  accessCounter = c ; }
  
  /**
   * @hibernate.property
   ***/
  public long getIllegalAccessCounter() {  return illegalAccessCounter ; }
  public void setIllegalAccessCounter(long c) {  illegalAccessCounter  =  c ; }
  
  /**
   * @hibernate.property
   ***/
  public long getErrorCounter() {  return errorCounter ; }
  public void setErrorCounter(long c) {  errorCounter =  c ; }
  
  /**
   * @hibernate.property
   ***/
  public long getSummaryAccessTime() {  return summaryAccessTime ; }
  public void setSummaryAccessTime(long c) {  summaryAccessTime =  c ; }
  
  public long getAvgAccessTime() { 
    if(accessCounter == 0) return 0 ;
    return summaryAccessTime / accessCounter ; 
  }
  
  public String getShortDateTime(){
    String dateTime =  String.valueOf(timeSlot.getDate())+ "-" + 
                       String.valueOf(timeSlot.getMonth() + 1) + "-" + 
                       String.valueOf(timeSlot.getYear()+ 1900) + " / " + 
                       String.valueOf(timeIndex) ;
    return dateTime ;
  }
  
  synchronized public void updatePortalAccess(long exeTime, boolean error) {
    accessCounter ++ ;
    if(error) errorCounter ++ ;
    summaryAccessTime += exeTime ;
  }
  synchronized public void logPortalAccess(String uniqueId, String pId, String owner, Date tSlot, 
                                           int tIndex, long exeTime, boolean error) {
    id           = uniqueId ;
    portalId     = pId ; 
    portalOwner  = owner ;
    timeSlot     = tSlot ;
    timeIndex    = tIndex ;
    strTimeSlot  = tSlot.toString() ;
    strTimeIndex = String.valueOf(tIndex) ;
    accessCounter ++ ;
    if(error) errorCounter ++ ;
    summaryAccessTime += exeTime ;
  }
  synchronized public void merge(PortalLogDataImpl other) {
    accessCounter += other.getAccessCounter() ;
    errorCounter += other.getErrorCounter() ;
    summaryAccessTime += other.getSummaryAccessTime() ;
  }
}